ghc-7.8.4: The GHC API

Safe Haskell | None
Language | Haskell98

Cmm

Contents

- Cmm top-level datatypes
  - Blocks containing lists
- Cmm graphs
- Info Tables
- Statements, expressions and types

Synopsis

- type CmmProgram = [CmmGroup]
- type CmmGroup = GenCmmGroup CmmStatics CmmTopInfo CmmGraph
- type GenCmmGroup d h g = [GenCmmDecl d h g]
- type CmmDecl = GenCmmDecl CmmStatics CmmTopInfo CmmGraph
- data GenCmmDecl d h g
  - = CmmProc h CLabel [GlobalReg] g
  - | CmmData Section d
- type CmmGraph = GenCmmGraph CmmNode
- data GenCmmGraph n = CmmGraph {
  - g_entry :: BlockId
  - g_graph :: Graph n C C
  }
- type CmmBlock = Block CmmNode C C
- type RawCmmDecl = GenCmmDecl CmmStatics (BlockEnv CmmStatics) CmmGraph
- type RawCmmGroup = GenCmmGroup CmmStatics (BlockEnv CmmStatics) CmmGraph
- data Section
  - = Text
  - | Data
  - | ReadOnlyData
  - | RelocatableReadOnlyData
  - | UninitialisedData
  - | ReadOnlyData16
  - | OtherSection String
- data CmmStatics = Statics CLabel [CmmStatic]
- data CmmStatic
  - = CmmStaticLit CmmLit
  - | CmmUninitialised Int
  - | CmmString [Word8]
- data GenBasicBlock i = BasicBlock BlockId [i]
- blockId :: GenBasicBlock i -> BlockId
- newtype ListGraph i = ListGraph [GenBasicBlock i]
- pprBBlock :: Outputable stmt => GenBasicBlock stmt -> SDoc
- type CmmReplGraph e x = GenCmmReplGraph CmmNode e x
- type GenCmmReplGraph n e x = UniqSM (Maybe (Graph n e x))
- type CmmFwdRewrite f = FwdRewrite UniqSM CmmNode f
- type CmmBwdRewrite f = BwdRewrite UniqSM CmmNode f
- data CmmTopInfo = TopInfo {
  - info_tbls :: BlockEnv CmmInfoTable
  - stack_info :: CmmStackInfo
  }
- data CmmStackInfo = StackInfo {
  - arg_space :: ByteOff
  - updfr_space :: Maybe ByteOff
  - do_layout :: Bool
  }
- data CmmInfoTable = CmmInfoTable {
  - cit_lbl :: CLabel
  - cit_rep :: SMRep
  - cit_prof :: ProfilingInfo
  - cit_srt :: C_SRT
  }
- topInfoTable :: GenCmmDecl a CmmTopInfo (GenCmmGraph n) -> Maybe CmmInfoTable
- data ClosureTypeInfo
  - = Constr ConstrTag ConstrDescription
  - | Fun FunArity ArgDescr
  - | Thunk
  - | ThunkSelector SelectorOffset
  - | BlackHole
  - | IndStatic
- data C_SRT
  - = NoC_SRT
  - | C_SRT !CLabel !WordOff !StgHalfWord
- needsSRT :: C_SRT -> Bool
- data ProfilingInfo
  - = NoProfilingInfo
  - | ProfilingInfo [Word8] [Word8]
- type ConstrDescription = [Word8]
- module CmmNode
- module CmmExpr

# Cmm top-level datatypes

type CmmProgram = [CmmGroup]

type CmmGroup = GenCmmGroup CmmStatics CmmTopInfo CmmGraph

type GenCmmGroup d h g = [GenCmmDecl d h g]

type CmmDecl = GenCmmDecl CmmStatics CmmTopInfo CmmGraph

data GenCmmDecl d h g

A top-level chunk, abstracted over the type of the contents of the basic blocks (Cmm or instructions are the likely instantiations).

Constructors

CmmProc h CLabel [GlobalReg] g |
CmmData Section d |

Instances

(Outputable d, Outputable info, Outputable i) => Outputable (GenCmmDecl d info i) |

type CmmGraph = GenCmmGraph CmmNode

data GenCmmGraph n

Constructors

CmmGraph |

Fields

g_entry :: BlockId
g_graph :: Graph n C C

Instances

Outputable CmmGraph |

type CmmBlock = Block CmmNode C C

type RawCmmDecl = GenCmmDecl CmmStatics (BlockEnv CmmStatics) CmmGraph

type RawCmmGroup = GenCmmGroup CmmStatics (BlockEnv CmmStatics) CmmGraph

data Section

Constructors

Text |
Data |
ReadOnlyData |
RelocatableReadOnlyData |
UninitialisedData |
ReadOnlyData16 |
OtherSection String |

data CmmStatics

Constructors

Statics CLabel [CmmStatic] |

Instances

Outputable CmmStatics |

data CmmStatic

Constructors

CmmStaticLit CmmLit |
CmmUninitialised Int |
CmmString [Word8] |

Instances

Outputable CmmStatic |

## Blocks containing lists

data GenBasicBlock i

Constructors

BasicBlock BlockId [i] |

Instances

Outputable instr => Outputable (GenBasicBlock instr) |

blockId :: GenBasicBlock i -> BlockId

The branch block id is that of the first block in the branch, which is that branch's entry point

newtype ListGraph i

Constructors

ListGraph [GenBasicBlock i] |

Instances

Outputable instr => Outputable (ListGraph instr) |

pprBBlock :: Outputable stmt => GenBasicBlock stmt -> SDoc

# Cmm graphs

type CmmReplGraph e x = GenCmmReplGraph CmmNode e x

type GenCmmReplGraph n e x = UniqSM (Maybe (Graph n e x))

type CmmFwdRewrite f = FwdRewrite UniqSM CmmNode f

type CmmBwdRewrite f = BwdRewrite UniqSM CmmNode f

# Info Tables

data CmmTopInfo

Constructors

TopInfo |

Fields

info_tbls :: BlockEnv CmmInfoTable
stack_info :: CmmStackInfo

Instances

Outputable CmmTopInfo |

data CmmStackInfo

Constructors

StackInfo |

Fields

arg_space :: ByteOff
updfr_space :: Maybe ByteOff
do_layout :: Bool

Instances

Outputable CmmStackInfo |

data CmmInfoTable

Info table as a haskell data type

Constructors

CmmInfoTable |

Fields

cit_lbl :: CLabel
cit_rep :: SMRep
cit_prof :: ProfilingInfo
cit_srt :: C_SRT

Instances

Outputable CmmInfoTable |

topInfoTable :: GenCmmDecl a CmmTopInfo (GenCmmGraph n) -> Maybe CmmInfoTable

data ClosureTypeInfo

Constructors

Constr ConstrTag ConstrDescription |
Fun FunArity ArgDescr |
Thunk |
ThunkSelector SelectorOffset |
BlackHole |
IndStatic |

Instances

Outputable ClosureTypeInfo |

data C_SRT

Constructors

NoC_SRT |
C_SRT !CLabel !WordOff !StgHalfWord |

Instances

Eq C_SRT |
Outputable C_SRT |

needsSRT :: C_SRT -> Bool

data ProfilingInfo

Constructors

NoProfilingInfo |
ProfilingInfo [Word8] [Word8] |

type ConstrDescription = [Word8]

# Statements, expressions and types

module CmmNode

module CmmExpr